 














.section .note.GNU-stack,"",@progbits; .previous

































	.text
	.align 2
	.globl mpaddw
mpaddw:

	mtctr r3
	slwi r0,r3,2
	add r4,r4,r0
	li r0,0
	lwzu r6,-4(r4)
	addc r6,r6,r5
	stw r6,0(r4)
	bdz .Lmpaddw_skip
.Lmpaddw_loop:
	lwzu r6,-4(r4)
	adde r6,r0,r6
	stw r6,0(r4)
	bdnz .Lmpaddw_loop
.Lmpaddw_skip:
	addze r3,r0
	blr




	.text
	.align 2
	.globl mpsubw
mpsubw:

	mtctr r3
	slwi r0,r3,2
	add r4,r4,r0
	li r0,0
	lwz r6,-4(r4)
	subfc r6,r5,r6
	stwu r6,-4(r4)
	bdz .Lmpsubw_skip
.Lmpsubw_loop:
	lwz r6,-4(r4)
	subfe r6,r0,r6
	stwu r6, -4(r4)
	bdnz .Lmpsubw_loop
.Lmpsubw_skip:
	subfe r3,r0,r0
	neg r3,r3
	blr




	.text
	.align 2
	.globl mpadd
mpadd:

	mtctr r3
	slwi r0,r3,2
	add r4,r4,r0
	add r5,r5,r0
	li r0,0
	lwz r6,-4(r4)
	lwzu r7,-4(r5)
	addc r6,r7,r6
	stwu r6,-4(r4)
	bdz .Lmpadd_skip
.Lmpadd_loop:
	lwz r6,-4(r4)
	lwzu r7,-4(r5)
	adde r6,r7,r6
	stwu r6,-4(r4)
	bdnz .Lmpadd_loop
.Lmpadd_skip:
	addze r3,r0
	blr




	.text
	.align 2
	.globl mpsub
mpsub:

	mtctr r3
	slwi r0,r3,2
	add r4,r4,r0
	add r5,r5,r0
	li r0,0
	lwz r6,-4(r4)
	lwzu r7,-4(r5)
	subfc r6,r7,r6
	stwu r6,-4(r4)
	bdz .Lmpsub_skip
.Lmpsub_loop:
	lwz r6,-4(r4)
	lwzu r7,-4(r5)
	subfe r6,r7,r6
	stwu r6,-4(r4)
	bdnz .Lmpsub_loop
.Lmpsub_skip:
	subfe r3,r0,r0
	neg r3,r3
	blr




	.text
	.align 2
	.globl mpmultwo
mpmultwo:

	mtctr r3
	slwi r0,r3,2
	add r4,r4,r0
	li r0,0
	lwz r6,-4(r4)
	addc r6,r6,r6
	stwu r6,-4(r4)
	bdz .Lmpmultwo_skip
.Lmpmultwo_loop:
	lwz r6,-4(r4)
	adde r6,r6,r6
	stwu r6,-4(r4)
	bdnz .Lmpmultwo_loop
.Lmpmultwo_skip:
	addze r3,r0
	blr




	.text
	.align 2
	.globl mpsetmul
mpsetmul:

	mtctr r3
	slwi r0,r3,2
	add r4,r4,r0
	add r5,r5,r0
	li r3,0
.Lmpsetmul_loop:
	lwzu r7,-4(r5)
	mullw r8,r7,r6
	addc r8,r8,r3
	mulhwu r9,r7,r6
	addze r3,r9
	stwu r8,-4(r4)
	bdnz .Lmpsetmul_loop
	blr




	.text
	.align 2
	.globl mpaddmul
mpaddmul:

	mtctr r3
	slwi r0,r3,2
	add r4,r4,r0
	add r5,r5,r0
	li r3,0
.Lmpaddmul_loop:
	lwzu r8,-4(r5)
	lwzu r7,-4(r4)
	mullw r9,r8,r6
	addc r9,r9,r3
	mulhwu r10,r8,r6
	addze r3,r10
	addc r9,r9,r7
	addze r3,r3
	stw r9,0(r4)
	bdnz .Lmpaddmul_loop
	blr




	.text
	.align 2
	.globl mpaddsqrtrc
mpaddsqrtrc:

	mtctr r3
	slwi r0,r3,2
	add r4,r4,r0
	add r5,r5,r0
	add r4,r4,r0
	li r3,0
.Lmpaddsqrtrc_loop:
	lwzu r0,-4(r5)
	lwz r6,-8(r4)
	lwz r7,-4(r4)
	mullw r9,r0,r0
	addc r9,r9,r3
	mulhwu r8,r0,r0
	addze r8,r8
	li r3,0
	addc r7,r7,r9
	adde r6,r6,r8
	addze r3,r3
	stw r7,-4(r4)
	stwu r6,-8(r4)
	bdnz .Lmpaddsqrtrc_loop
	blr

